<?php

// Copyright (C) 2008-2011 Lonnie Abelbeck
// This is free software, licensed under the GNU General Public License
// version 3 as published by the Free Software Foundation; you can
// redistribute it and/or modify it under the terms of the GNU
// General Public License; and comes with ABSOLUTELY NO WARRANTY.

// template.php for AstLinux
// 2011-06-15
//

$myself = $_SERVER['PHP_SELF'];

require_once '../common/functions.php';

// Function: saveTEMPLATEsettings
//
function saveTEMPLATEsettings($db, $delete = NULL) {

  if (($n = count($db['data'])) > 0) {
    for ($i = 0; $i < $n; $i++) {
      $skip = FALSE;
      if (! is_null($delete)) {
        for ($j = 0; $j < count($delete); $j++) {
          if ($delete[$j] == $i) {
            $skip = TRUE;
            break;
          }
        }
      }
      if (! $skip) {
        ; // Save Data using $db['data'][$i]
          // For Asterisk astdb use putAstDB() and delAstDB()
      }
    }
  }

  return(11);
}

// Function: parseTEMPLATEconf
//
function parseTEMPLATEconf() {
  $id = 0;
  
  $test_data = "one~1\ntwo~2\nthree~3\n";
  // Example test data, this would actually be read from a file
  // for from the Asterisk astdb using parseAstDB()

  if (($line = $test_data) !== '') {
    $linetokens = explode("\n", $line);
    foreach ($linetokens as $data) {
      if ($data !== '') {
        $datatokens = explode('~', $data);
        $db['data'][$id]['name'] = $datatokens[0];
        $db['data'][$id]['num'] = $datatokens[1];
        $id++;
      }
    }
  }
  // Sort by Name
  if ($id > 1) {
    foreach ($db['data'] as $key => $row) {
      $name[$key] = $row['name'];
    }
    array_multisort($name, SORT_ASC, SORT_STRING, $db['data']);
  }
  return($db);
}

$db = parseTEMPLATEconf();

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
  $result = 1;
  if (! $global_admin) {  // Use $global_staff for 'staff' permissions.  Use TRUE for 'all' permissions.
    $result = 999;                                 
  } elseif (isset($_POST['submit_save'])) {
    $result = saveTEMPLATEsettings($db);
  } elseif (isset($_POST['submit_delete'])) {
    $delete = $_POST['delete'];
    if (count($delete) > 0) {
      $result = saveTEMPLATEsettings($db, $delete);
    }
  }
  header('Location: '.$myself.'?result='.$result);
  exit;
} else { // Start of HTTP GET
$ACCESS_RIGHTS = 'admin';  // Use 'staff' for 'staff' permissions.  Use 'all' for 'all' permissions.
require_once '../common/header.php';

  putHtml("<center>");
  if (isset($_GET['result'])) {
    $result = $_GET['result'];
    if ($result == 11) {
      putHtml('<p style="color: green;">Settings saved (not actually).</p>');
    } elseif ($result == 99) {
      putHtml('<p style="color: red;">Action Failed.</p>');
    } elseif ($result == 999) {
      putHtml('<p style="color: red;">Permission denied for user "'.$global_user.'".</p>');
    } else {
      putHtml('<p style="color: orange;">No Action.</p>');
    }
  } else {
    putHtml('<p>&nbsp;</p>');
  }
  putHtml("</center>");
?>
  <center>
  <table class="layout"><tr><td><center>
  <form method="post" action="<?php echo $myself;?>">
  <table width="100%" class="stdtable">
  <tr><td style="text-align: center;" colspan="2">
  <h2>Template Example:</h2>
  </td></tr><tr><td style="text-align: center;">
  <input type="submit" class="formbtn" value="Save Settings" name="submit_save" />
  &nbsp;
  </td><td style="text-align: center;">
  &nbsp;
  <input type="submit" class="formbtn" value="Delete Checked" name="submit_delete" />
  </td></tr>
  </table>
  
<?php
  if (isset($_GET['id'])) {
    $id = $_GET['id'];
    $n = count($db['data']);
    if ($id < $n && $id >= 0) {
      $ldb = $db['data'][$id];
    }
  }
  if (is_null($ldb)) {
    $ldb['name'] = '';
    $ldb['num'] = '';
  }
  putHtml('<table class="stdtable">');
  putHtml('<tr><td class="dialogText" style="text-align: right;">');
  putHtml('Text Input:<input type="text" size="24" maxlength="128" name="name" value="'.$ldb['name'].'" />');
  putHtml('</td><td class="dialogText" style="text-align: right;">');
  putHtml('Number Input:<input type="text" size="8" maxlength="16" name="num" value="'.$ldb['num'].'" />');
  putHtml('</td></tr>');
  putHtml('</table>');
  
  putHtml('<table width="100%" class="datatable">');
  putHtml('<tr>');
  
  if (($n = count($db['data'])) > 0) {
    echo '<td class="dialogText" style="text-align: left; font-weight: bold;">', "Text Input", "</td>";
    echo '<td class="dialogText" style="text-align: left; font-weight: bold;">', "Number Input", "</td>";
    echo '<td class="dialogText" style="text-align: center; font-weight: bold;">', "Delete", "</td>";
    for ($i = 0; $i < $n; $i++) {
      putHtml("</tr>");
      echo '<tr ', ($i % 2 == 0) ? 'class="dtrow0"' : 'class="dtrow1"', '>';
      echo '<td>', '<a href="'.$myself.'?id='.$i.'" class="actionText">'.$db['data'][$i]['name'].'</a>', '</td>';
      echo '<td>', $db['data'][$i]['num'], '</td>';
      echo '<td style="text-align: center;">', '<input type="checkbox" name="delete[]" value="', $i, '" />', '</td>';
    }
  } else {
    echo '<td style="text-align: center;">No entries are defined.', '</td>';
  }
  
  putHtml('</tr>');
  putHtml('</table>');
  putHtml('</form>');
  putHtml('</center></td></tr></table>');
  putHtml('</center>');
} // End of HTTP GET
require_once '../common/footer.php';

?>
